<?php
/*
Plugin Name: 2ch Tripize
Plugin URI: http://qyens-labo.net/2009/07/29/trip_on_comment/
Description: コメント欄のトリップ対応
Author: qyen
Version: 1.0.0
Author URI: http://www.qyen.info/
*/
/*
 * 注意点とか。
 * ----------------------------------------------------
 * コメント投稿にオーナーの承認を必要としてる場合、コメント投稿後の画面に
 * 自分の承認前コメントが表示されますが、トリップ付きのコメントはこれを表示
 * することができません。(*1)
 * このため、投稿出来てないと思われて重複投稿されることが予想されますので
 * 承認なしで投稿を許すか、承認されるまで表示されない旨のコメントを表示する
 * などの対策が推奨されます。
 * 
 * 個人的にはcaptha認証との組み合わせ+承認なしで投稿の組み合わせが
 * 良いんじゃないかと。
 * 
 * ----------------------------------------------------
 * *1 cookieに変換前のトリップを登録してるから
 */
	
	/**
	 * トリップ生成
	 * @return 
	 * @param $from Object
	 */
	function trippize($from){
		//★を☆に置換
		$from = str_replace("★", "☆", $from);
		//◆を◇に置換
		$from = str_replace("◆", "◇", $from);
		if (($sharp = mb_strpos($from, '#')) !== false ) {
			$GLOBALS["pretripstring"] = $from;
			$trip_key = mb_substr($from, ($sharp + 1));
			$char = mb_internal_encoding();
			mb_convert_variables("Shift-JIS", $char, $trip_key); 
			
			$salt = mb_substr("$trip_key".'H.', 1, 2);
			$salt = str_replace(
								array(':', ';', '<', '=', '>', '?', '@', '[', '\\', ']', '^', '_', '`',),
								array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'a', 'b',  'c', 'd', 'e', 'f',)
								,$salt);
			
			$salt = preg_replace('/[^\.\/0-9A-Za-z]/', '.', $salt);
			$trip = mb_substr(crypt($trip_key, $salt), -10);
			$name = mb_substr($from, 0, $sharp);
			$from = $name."◆$trip";
		}
		return $from;
	}
	
	/**
	 * トリップ化
	 * @return 
	 * @param $commentinfo Object
	 */
	function filter_2chtripize($commentinfo) {
		$commentinfo["comment_author"] = trippize(stripcslashes($commentinfo["comment_author"]));
	    return $commentinfo;
	}
	
	/**
	 * トリップ生成前の文字列を使ってクッキーを上書き
	 * （これをしないと次のコメント時名前にトリップが出るんで具合悪い）
	 * @return 
	 * @param $location Object
	 * @param $comment Object
	 */
	function filter_2chtripize_aplycookie($location, $comment){
		if (!empty($GLOBALS["pretripstring"])){
			$comment_cookie_lifetime = 30000000;
			$pretripstring = $GLOBALS["pretripstring"];
			setcookie('comment_author_' . COOKIEHASH, $pretripstring, time() + $comment_cookie_lifetime, COOKIEPATH, COOKIE_DOMAIN);
		}
		return $location ;
	}
	add_filter('comment_post_redirect', 'filter_2chtripize_aplycookie',0,2);
	add_filter('preprocess_comment', 'filter_2chtripize', 0);
	
//	add_filter('comment_save_pre', 'filter_2chtripize', 0);
//	add_filter('pre_comment_author_name', 'filter_2chtripizestr', 0);
?>
